package com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.linked_issue;

import com.arms.api.issue.almapi.model.entity.AlmIssueEntity;
import com.arms.api.issue.almapi.model.vo.지라이슈_데이터;
import com.arms.api.issue.almapi.model.dto.요구사항_데이터;
import com.arms.api.issue.schedule.service.jiraissue_schedule.alm_entity_sync.지라이슈_엔티티_컬렉션;
import com.arms.api.issue.almapi.service.이슈전략_호출;
import com.arms.api.util.alm.지라이슈_생성;
import com.arms.egovframework.javaservice.esframework.repository.EsCommonRepositoryWrapper;

import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;

import java.util.*;

import static com.arms.config.ApplicationContextProvider.getBean;

@Slf4j
public class 연결이슈_처리 extends EsCommonRepositoryWrapper<AlmIssueEntity> {

    private final 지라이슈_엔티티_컬렉션 지라이슈_엔티티_저장_목록 = new 지라이슈_엔티티_컬렉션(new ArrayList<>());

    private final List<지라이슈_데이터> 지라이슈_데이터_연결이슈_목록;

    private final 요구사항_데이터 요구사항_데이터;

    public 연결이슈_처리(요구사항_데이터 요구사항_데이터, List<지라이슈_데이터> 지라이슈_데이터_연결이슈_목록) {
        this.요구사항_데이터 = 요구사항_데이터;
        this.지라이슈_데이터_연결이슈_목록 = 지라이슈_데이터_연결이슈_목록;
    }

    public static 연결이슈_처리 연결이슈_처리(요구사항_데이터 요구사항_데이터) throws Exception {
        연결이슈_처리 연결이슈_처리 = new 연결이슈_처리(요구사항_데이터, getBean(이슈전략_호출.class).연결이슈_가져오기(요구사항_데이터));
        연결이슈_처리.연결이슈_데이터_이슈엔티티_변환_적용();
        return 연결이슈_처리;
    }


    public List<AlmIssueEntity> get지라이슈_엔티티_저장_목록() {
        return 지라이슈_엔티티_저장_목록.getAlmIssueEntity_목록();
    }

    private void 연결이슈_데이터_이슈엔티티_변환_적용(){
        this.연결이슈_데이터_이슈엔티티_변환_적용(지라이슈_데이터_연결이슈_목록);
    }

    // 연결이슈_데이터_엔티티_변환
    private void 연결이슈_데이터_이슈엔티티_변환_적용(List<지라이슈_데이터> 연결이슈_목록) {
        연결이슈_목록.forEach(ALM연결이슈 -> {
            // 조회한 연결이슈가 요구사항 or ALM에서 생성하지 않은 이슈 or 다른 요구사항의 하위 이슈인 경우 고려해야 함
            String 조회조건_아이디 = 요구사항_데이터.연결이슈_조회조건_아이디(ALM연결이슈);

            AlmIssueEntity almIssueEntity = this.findRecentDocById(조회조건_아이디);

            Optional<AlmIssueEntity> 저장할_이슈_엔티티 = 지라이슈_엔티티_저장_목록.getAlmIssueEntity_목록().stream()
                    .filter(이슈 -> {
                        String 비교_아이디 = 이슈.조회조건_아이디();
                        return 비교_아이디.equals(조회조건_아이디);
                    })
                    .findFirst();

            if (ES_없거나_ALM_자체_생성_연결이슈_이면(almIssueEntity, 요구사항_데이터)
                    && !isRequirementIssue(almIssueEntity)
                    && 저장할_이슈_엔티티.isEmpty()) {

                //계속 덮어씌우기 때문에 마지막 형상 저장->추후에 상황을 검토후 개선 할 목적으로 남김
                AlmIssueEntity 변환된_이슈 = 지라이슈_생성.ELK_데이터로_변환(
                        요구사항_데이터.get지라서버_아이디()
                        , ALM연결이슈
                        , false // 요구사항여부 : 요구사항이 아니므로 fasle 처리
                        , 요구사항_데이터.get이슈_키() // 부모 요구사항 키: 요구사항 이슈의 키를 대입.
                        , 요구사항_데이터.get제품서비스_아이디() // 제품 서비스: 다른 제품 서비스 가능
                        , 요구사항_데이터.get제품서비스_버전들() // 버전: 다른 버전의 요구사항 연결 가능
                        , 요구사항_데이터.getCReqLink() // 요구사항 아이디: 다른 요구사항 연결 가능
                        , 요구사항_데이터.getCReqProperty()
                        , ALM연결이슈.getRawData()
                );

                지라이슈_엔티티_저장_목록.엔티티_추가(변환된_이슈);
            }

        });
    }

    private boolean isRequirementIssue(AlmIssueEntity almIssueEntity) {
        if (almIssueEntity == null) {
            return true;
        }

        return almIssueEntity.getIsReq() != null && almIssueEntity.getIsReq().equals(Boolean.TRUE);
    }

    private boolean ES_없거나_ALM_자체_생성_연결이슈_이면(AlmIssueEntity almIssueEntity, 요구사항_데이터 requirementDTO) {

        if (isParentKeyDifferentRequirementKey(almIssueEntity, requirementDTO)) {
            log.info("[ 연결이슈_처리 :: ES_없거나_ALM_자체_생성_연결이슈_이면 ] :: 기존에 존재하는 연결이슈의 부모키 => {}, 들어온 요구사항의 이슈 키 => {}", almIssueEntity.getParentReqKey(), requirementDTO.get이슈_키());
        }

        return almIssueEntity == null // 조회 결과가 null => false
                || isUpperKeyMissingAndNotRequirementIssue(almIssueEntity)
                || parentKeyPresentAndNotEqualToRequirementKey(almIssueEntity, requirementDTO);
    }

    private boolean isParentKeyDifferentRequirementKey(AlmIssueEntity almIssueEntity, 요구사항_데이터 requirementDTO) {
        return almIssueEntity != null && almIssueEntity.getParentReqKey() != null
                && !StringUtils.equals(almIssueEntity.getParentReqKey(), requirementDTO.get이슈_키());
    }

    private boolean isUpperKeyMissingAndNotRequirementIssue(AlmIssueEntity almIssueEntity) {
        return almIssueEntity != null && almIssueEntity.getUpperKey() == null && almIssueEntity.getIsReq() != Boolean.TRUE;
    }

    private boolean parentKeyPresentAndNotEqualToRequirementKey(AlmIssueEntity almIssueEntity, 요구사항_데이터 requirementDTO) {
        return almIssueEntity != null && almIssueEntity.getParentReqKey() != null
                && !almIssueEntity.getParentReqKey().equals(requirementDTO.get이슈_키());
    }

    public List<String> 연결이슈_아이디_배열_가져오기() throws Exception {

        Set<String> 연결이슈_아이디_세트 = 연결이슈_가져오기();

        if (연결이슈_세트가_비어있으면(연결이슈_아이디_세트)) {
            return new ArrayList<>();
        } else {
            return new ArrayList<>(연결이슈_아이디_세트);
        }
    }

    private boolean 연결이슈_세트가_비어있으면(Set<String> 연결이슈_아이디_세트) {
        return 연결이슈_아이디_세트.isEmpty();
    }

    private Set<String> 연결이슈_가져오기() throws Exception {

        Set<String> 연결이슈_아이디_세트 = new HashSet<>();

        List<지라이슈_데이터> 연결이슈_목록 =
                Optional.ofNullable(ALM_연결이슈_가져오기())
                        .orElse(Collections.emptyList());

        if (!연결이슈_목록.isEmpty()) {
            for (지라이슈_데이터 ALM_데이터 : 연결이슈_목록) {
                연결이슈_아이디_세트.add(ALM_데이터.조회조건_아이디());
            }
        }

        return 연결이슈_아이디_세트;
    }

    private List<지라이슈_데이터> ALM_연결이슈_가져오기() throws Exception {
        return getBean(이슈전략_호출.class).연결이슈_가져오기(요구사항_데이터);
    }



}
