package com.arms.egovframework.javaservice.esframework.esquery.filter;

import java.util.Arrays;
import java.util.List;
import java.util.stream.Collectors;

import org.elasticsearch.index.query.AbstractQueryBuilder;
import org.elasticsearch.index.query.QueryBuilders;
import org.elasticsearch.index.query.TermQueryBuilder;

import com.arms.egovframework.javaservice.esframework.esquery.Filter;

public class TermQueryFilter extends Filter<TermQueryBuilder> {

	private TermQueryBuilder termQueryBuilder;

	public TermQueryFilter(String name, Object value){
		if(name!=null&&value!=null){
			this.termQueryBuilder = QueryBuilders.termQuery(name, value);
		}
	}

	public TermQueryFilter(String name, String value){
		if(name!=null&&value!=null){
			this.termQueryBuilder = QueryBuilders.termQuery(name, value);
		}
	}

	public TermQueryFilter(String name, Long value){
		if(name!=null&&value!=null){
			this.termQueryBuilder = QueryBuilders.termQuery(name,value);
		}
	}

	public TermQueryFilter(String name, boolean value){
		if(name!=null){
			this.termQueryBuilder = QueryBuilders.termQuery(name, value);
		}
	}

	@Override
	public AbstractQueryBuilder<TermQueryBuilder> abstractQueryBuilder() {
		return  termQueryBuilder;
	}

}
